<template>
  <div class="style__amortizacionContract">
    <div style="margin: 7rem 4rem">
      <Header :returnPage="returnPage" />
      <section style="margin: 4rem 1rem 1rem 4rem">
        <el-row :gutter="20" style="padding: 7rem 0 4rem 0">
          <el-col :span="6" :offset="17">
            <el-input
              class="input-head"
              placeholder="Buscar"
              prefix-icon="el-icon-search"
              v-model="textSearch"
            ></el-input>
          </el-col>
        </el-row>
        <el-row>
          <el-col
            style="width: 100%"
            class="pr-50"
            v-if="newListMaterials.length == 0"
          >
            <el-card :body-style="{ padding: '0px' }" class="bg-gray">
              <el-col :span="8" style="margin-top: 1rem" class="text-center">
                <img src="@/assets/images/detective.svg" alt />
              </el-col>
              <el-col :span="16">
                <div style="margin-top: 5rem">
                  <p class="title-styles">¡Lo sentimos!</p>
                  <p class="title-styles">
                    El contrato con codigo {{ dataContract.codeContract }} no
                    tiene materiales asignados.
                  </p>
                </div>
              </el-col>
            </el-card>
          </el-col>
          <div
            class="flex text-white bg-orange my-25"
            style="align-items: center"
          >
            <h4 class="font-size-25 flex" style="padding: 10px 20px 10px 40px">
              {{ dataContract.title }}
            </h4>
            <p class="font-size-16">
              (Cod. Contrato: {{ dataContract.codeContract }})
            </p>
          </div>
          <FilterMaterialAmort
            v-for="(materials, index) in itemContract"
            :key="index"
            :listChapters="listChapters(index)"
            :materials="materials"
            :originalMaterial="orginalListMaterials[index]"
            :exedPercent="exedPercent"
            @updateData="updateData"
            @makeAmortization="makeAmortization"
            @changeExedPercent="changeExedPercent"
            @captureNumber="capturingNumberAmortization(index)"
            @saveChangePasse="saveChangePasse"
          />
        </el-row>
      </section>
      <!-- MODALES  -->
      <!-- modal alerta cuando supera el 100% -->
      <AppModal
        :show-dialog.sync="exedPercent"
        v-if="exedPercent"
        nameClass="dialog-red"
        :rutImg="require(`@/assets/images/alerta.svg`)"
        sizeImg="80px"
        textBold="¡Un momento!"
        :parrafo="'La amortizacion supera el 100% '"
        v-on:eventBtn="exedPercent = false"
      />
      <!-- modal ingresa la nueva amortizacion -->
      <AppModal
        :show-dialog.sync="modalAmortizar"
        v-if="modalAmortizar"
        nameClass="dialog-orange"
        :rutImg="require(`@/assets/images/happy.svg`)"
        textBold="¡Buen trabajo!"
        :parrafo="textUpdate"
        v-on:eventBtn="modalAmortizar = false"
      />
    </div>
    <!-- MODAL DE ESPERA MIENTRAS SE APRUEBA-->
    <AppModal
      :show-dialog.sync="loadingModal"
      v-if="loadingModal"
      nameClass="dialog-red"
      :styleModal="loadingModal"
      :rutImg="require(`@/assets/images/alerta.svg`)"
      sizeImg="80%"
      :parrafo="`<p>Por favor, <span class='text-bold'> ESPERE </span> mientras se guarda la información... <br>  <span class='text-bold'> Este proceso durará 05 segundos aproximadamente. </span> </p>`"
    />
    <AppModal
      :show-dialog.sync="modalChangePass"
      v-if="modalChangePass"
      nameClass="dialog-orange"
      :rutImg="require(`@/assets/images/happy.svg`)"
      textBold="¡Buen trabajo!"
      :parrafo="'Se han cambiado la cantidad de pasadas de este material.'"
      v-on:eventBtn="modalChangePass = false"
    />
  </div>
</template>
<script>
import ReturnButton from '@/components/ReturnButton.vue'
import AppModal from '@/components/AppModal.vue'
import MaterialAmortization from './MaterialAmortization'
import FilterMaterialAmort from './FilterMaterialAmort'
import Header from '@/components/amortizationOfContract/Header.vue'
import { HTTP } from '@/main.js'

export default {
  components: {
    MaterialAmortization,
    FilterMaterialAmort,
    ReturnButton,
    AppModal,
    Header,
  },
  data() {
    return {
      listMaterials: [],
      newListMaterials: [],
      listCodes: [],
      listMaterialPerChap: [],
      listMaterialPerChap2: [],
      arrayAmort: [],
      contractJson: JSON.parse(this.$localStorage.get('amortContract')),
      filterSelect: '',
      textSearch: '',
      numberAmortization: [],
      amortization: 0,
      parent_id: [],
      prueba: [],
      prueba: false,
      db: [],
      total: [],
      id: '',
      exedPercent: false,
      modalAmortizar: false,
      modalChangePass: false,
      userName: '',
      userEmail: localStorage.getItem('userEmail'),
      loadingModal: false,
      alertMessage: {
        show: false,
        message: '',
      },
      passToMaterial: [],
      pasadas: 5,
      dataContract: {},
      orginalListMaterials: [],
    }
  },
  created() {
    const { listMaterials, contract, listMaterialsAgrupado } = JSON.parse(
      this.$localStorage.get('contractAmort')
    )
    this.orginalListMaterials = JSON.parse(
      JSON.stringify(listMaterialsAgrupado)
    )
    this.newListMaterials = listMaterialsAgrupado
    this.listMaterials = listMaterials
    this.dataContract = contract
  },
  computed: {
    itemContract() {
      let filtered = this.newListMaterials
      let response
      if (!this.textSearch) {
        response = filtered
      } else {
        this.textSearch = this.textSearch.trim().toLowerCase()
        filtered = filtered.filter((item) => {
          if (item.listTitle.toLowerCase().indexOf(this.textSearch) !== -1) {
            console.log({ response })
            return item
          }
        })
        response = filtered
      }
      return response
    },
  },
  methods: {
    saveChangePasse() {
      this.modalChangePass = true
    },
    async updateData(val) {
      const { codeContract } = val
      await HTTP.get(`amortization/ofContract/${codeContract}`)
        .then((res) => {
          console.log(res)
          this.$localStorage.set('contractAmort', JSON.stringify(res.data))

          const { listMaterials, contract, listMaterialsAgrupado } = JSON.parse(
            this.$localStorage.get('contractAmort')
          )
          this.newListMaterials = listMaterialsAgrupado
          this.listMaterials = listMaterials
          this.dataContract = contract
        })
        .catch((err) => console.log(err))
    },
    changeExedPercent() {
      this.exedPercent = true
    },
    listChapters(index) {
      let listMats = this.newListMaterials.map((el) => {
        return el.detalleCapitulos
      })
      let listChapters = listMats[index].map((e) => e.numChapter)
      return listChapters
    },
    async makeAmortization(val) {
      this.loadingModal = true
      const { item, percentTotal, chapter, list } = val
      console.log({ chapter, list })
      const { data } = await HTTP.post('amortization/existSchema', {
        percentage: percentTotal,
      })
      const { info, exist } = data
      let text = null
      if (exist == true) {
        let select = info[0]
        let conditional =
          list.length >= 2
            ? `<strong>capítulo${chapter}</strong> del material <strong>${item.listTitle}</strong>`
            : `material ${item.listTitle}`
        text = `<p>Se actualizó la amortización del ${conditional} ahora su esquema de amortización es del <strong>Tipo${select.numbPercent}(${select.tpr_codigo})</strong></p>`
      } else {
        let conditional =
          list.length >= 2
            ? `<strong>capítulo${chapter}</strong> del material <strong>${item.listTitle}</strong>`
            : `material ${item.listTitle}`
        text = `<p>Se creó un nuevo esquema de amortización con los porcentajes de <strong>${percentTotal}</strong> y se actualizó el ${conditional}</p>`
      }
      this.textUpdate = text
      this.loadingModal = false
      this.modalAmortizar = true
    },
    gettingUsername() {
      let user = this.userEmail.split('@')[0]
      this.userName = user.toUpperCase()
    },
    cancelarAmortizacion(item) {
      item.rendering = false
    },
    returnPage() {
      this.$router.push({ name: 'contract' })
    },
  },
}
</script>

<style>
.style__amortizacionContract .el-button--gray {
  background-color: #555f79 !important;
  border-color: #555f79 !important;
}

.style__amortizacionContract .el-button--gray:hover {
  background-color: #7c8292 !important;
  border-color: #7c8292 !important;
}

.style__amortizacionContract .bg-orange {
  background-color: #ff5000 !important;
  opacity: 0.8;
}
</style>
